// IceCreamOrder.h : Declaration of the CIceCreamOrder

#ifndef __ICECREAMORDER_H_
#define __ICECREAMORDER_H_

#include "resource.h"       // main symbols
#include <vector>



//defines
#define NUMBER_OF_FLAVORS_AVAILABLE  5
 

/////////////////////////////////////////////////////////////////////////////
// CIceCreamOrder
class ATL_NO_VTABLE CIceCreamOrder : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CIceCreamOrder, &CLSID_IceCreamOrder>,
	public IDispatchImpl<IIceCreamOrder, &IID_IIceCreamOrder, &LIBID_ICECREAMLib>
{
public:
	CIceCreamOrder()
	{
	}

DECLARE_REGISTRY_RESOURCEID(IDR_ICECREAMORDER)
DECLARE_NOT_AGGREGATABLE(CIceCreamOrder)



BEGIN_COM_MAP(CIceCreamOrder)
	COM_INTERFACE_ENTRY(IIceCreamOrder)
	COM_INTERFACE_ENTRY(IDispatch)
END_COM_MAP()


HRESULT FinalConstruct()
{

	//Here are all the flavors that we have
   m_vecIcecreamFlavors.push_back(CComBSTR(L"Peach Melba"));
   m_vecIcecreamPrices.push_back(5.00);			
   m_vecIcecreamFlavors.push_back(CComBSTR(L"Chocolate Chip"));
   m_vecIcecreamPrices.push_back(7.00);			
   m_vecIcecreamFlavors.push_back(CComBSTR(L"Black Currant"));
   m_vecIcecreamPrices.push_back(8.00);			
   m_vecIcecreamFlavors.push_back(CComBSTR(L"Rasberry"));
   m_vecIcecreamPrices.push_back(6.00);			
   m_vecIcecreamFlavors.push_back(CComBSTR(L"Butterscotch Crunch"));
   m_vecIcecreamPrices.push_back(10.00);			
	
   return S_OK;


}



// IIceCreamOrder
public:
	
	STDMETHOD(GetFlavorsWithPrices)(VARIANT* pVariant);
	STDMETHOD(GetFlavors)(/*[out]*/ VARIANT* pSafeArr);



private:

	//Use STL vectors to store our data

	std::vector<CComBSTR> m_vecIcecreamFlavors;
	std::vector<float> m_vecIcecreamPrices;	





};

#endif //__ICECREAMORDER_H_
